/*      file     : TrafficData/TAccessoryHandler.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TAccessoryHandler.h,v 1.4 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TACCESSORYHANDLER_H
#define TACCESSORYHANDLER_H

// ***INCLUDES************************************************************************ 

#include <TParallelObject.h>

// ***FORWARDS************************************************************************

class TAsciiDataTypeReader;
class TBaseStream;
class TClassInfo;

#include "TAccessory.forward.h"

// ***CLASSES************************************************************************* 

class TAccessoryHandler : public TParallelObject

{
public:

    TAccessoryHandler(TParallelID theParallelID);
    virtual ~TAccessoryHandler(void);

    static TClassInfo *ClassInfo;

    bool
    Activate(const TDistributedRange &);

    bool
    ExecuteSubTimeStep(const TTimeStep &TimeStep);

    bool
    LoadAccessories(TInfoID theAdjacenceInfoID, TAsciiDataTypeReader *Reader);

private:

    // dependant data:
    
    TAccessoryList *Accessories;

    // const data:

    TInfoID AdjacenceInfoID;

    
    virtual bool
    Decode(TBaseStream *aStream, TTransferInfo *TransferInfo);

    virtual bool
    DisposeRange(TDistributedRange *Range);

    virtual bool
    Encode(TBaseStream *aStream, TTransferInfo *TransferInfo) const;

    virtual TString
    GetClassName(void) const;

    virtual TString
    GetInstanceName(void) const;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
