/*      file     : xparallel/TGraphEdgeInfo.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TGraphEdgeInfo.h,v 1.4 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TGRAPHEDGEINFO_H
#define TGRAPHEDGEINFO_H

// ***INCLUDES************************************************************************ 

#include <TLocation.h>
#include <TParallelObject.h>

// ***CLASSES************************************************************************* 

class TGraphEdgeInfo : public TParallelObject

{
public:
    
    TGraphEdgeInfo(TParallelID theParallelID);

    virtual TString
    GetClassName(void) const;

    bool
    LoadLocations(TInfoID AdjInfoID, TInfoID LocInfoID);

    static TClassInfo *ClassInfo;
    
    TLocation From;
    TLocation To;
    double    EffectiveLength;
    double    FreeFlowSpeed;
    int       FromColor;
    int       ToColor;
    int       NrOfLanes;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
