/*      file     : TrafficData/TIntersection.i.C
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TIntersection.i.C,v 1.5 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************

#include "TIntersectionControl.h"

// ***METHODS************************************************************************* 

inline TIncidenceInfo *
TIntersection::GetIncidenceInfo(void) 

{
    return IncidenceInfo;
}

// ===================================================================================


inline TMultilaneGrid *
TIntersection::GetIncomingGrid(int Nr) const

{
    return IncomingGrids[Nr];
}

// ===================================================================================

inline TMultilaneGrid *
TIntersection::GetOutgoingGrid(int Nr) const

{
    return OutgoingGrids[Nr];
}

// ===================================================================================

inline bool
TIntersection::IsIncomingSegmentActive(long EdgeNr)

{
    if (IntersectionControl)
        return IntersectionControl->IsIncomingSegmentActive(EdgeNr);
    else
        return TRUE;    
}

// ===================================================================================

inline bool
TIntersection::IsIncomingVehicleActive(long EdgeNr)

{
    if (IntersectionControl)
        return IntersectionControl->IsIncomingVehicleActive(EdgeNr);
    else
        return TRUE;
}

// =================================================================================== 


