/*      file     : TrafficData/TrafficDataTypes.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TrafficDataTypes.h,v 1.5 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TRAFFICDATATYPES_H
#define TRAFFICDATATYPES_H

// ***INCLUDES************************************************************************ 

#include <ParStatTypes.h>

// ***DEFINES************************************************************************* 

#define CLASS_SIMPLE_INTERSECTION        "SimpleIntersection"
#define CLASS_INTERSECTION_CONTROL       "IntersectionControl"
#define CLASS_ACCESSORY                  "Accessory"
#define CLASS_ACCESSORY_HANDLER          "AccessoryHandler"
#define CLASS_SOURCE                     "Source"
#define CLASS_SINK                       "Sink"
#define CLASS_MULTILANE_GRID             "MultilaneGrid"
#define CLASS_MULTILANE_BOUNDARY         "MultilaneBoundary"
#define CLASS_MULTILANE_STAT             "MultilaneStat"
#define CLASS_MULTILANE_DUMP             "MultilaneDump"
#define CLASS_GRID_STAT                  "GridStat"
#define CLASS_GRID_STAT_LOOKUP           "GridStatLookup"
#define CLASS_LOCAL_GRID_STAT_LOOKUP     "LocalGridStatLookup"
#define CLASS_VEHICLE                    "Vehicle"
#define CLASS_ROUTEPLAN                  "Routeplan"
#define CLASS_ROUTINGSTAT                "RoutingStat"
#define CLASS_GRAPH_EDGE_INFO            "GraphEdgeInfo"
#define CLASS_NODE_TIMER                 "NodeTimer"
#define CLASS_EDGE_TIMER                 "EdgeTimer"
#define CLASS_NODE_TIME_STAT             "NodeTimeStat"
#define CLASS_EDGE_TIME_STAT             "EdgeTimeStat"
#define CLASS_TURN_COUNT_STAT            "TurnCountStat"

#define SAMPLING_ID_GLOBAL_CA_STAT     SAMPLING_FIRST_FREE_ID
#define SAMPLING_ID_ROUTING_STAT      (SAMPLING_FIRST_FREE_ID + 1)
#define SAMPLING_ID_GRID_STAT         (SAMPLING_FIRST_FREE_ID + 2)
#define SAMPLING_ID_LOCAL_GRID_STAT   (SAMPLING_FIRST_FREE_ID + 3)
#define SAMPLING_ID_EDGE_TIME_STAT    (SAMPLING_FIRST_FREE_ID + 4)
#define SAMPLING_ID_NODE_TIME_STAT    (SAMPLING_FIRST_FREE_ID + 5)
#define SAMPLING_ID_TURN_COUNT_STAT   (SAMPLING_FIRST_FREE_ID + 6)
#define SAMPLING_ID_CA_DUMP_BASE      (SAMPLING_FIRST_FREE_ID + 7) // keep next IDs free

#define MEVENT_ROUTER_COMPLETED_ROUTE   1

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
