/*      file     : TrafficData/Transims.C
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: Transims.C,v 1.2 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include "Transims.h"

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***GLOBAL VARIABLES****************************************************************  
// ***LOCAL VARIABLES***************************************************************** 
// ***FUNCTIONS*********************************************************************** 

unsigned long
PaminaEdge2TransimsLink(long EdgeID)

{
    return (EdgeID >> 1) & 0x7FFFFFFF;
}

// =================================================================================== 

int
TransimsLinkColor(double Ratio, int MaxColors)

{    
    double Color;

    if (Ratio ==  -1.0)
        Color = 0.0;
    else if (Ratio < 0.05)
        Color = 1.0;
    else if (Ratio < 0.1)
        Color = 0.8;
    else if (Ratio < 0.2)
        Color = 0.6;
    else if (Ratio < 0.3)
        Color = 0.4;
    else if (Ratio < 0.4)
        Color = 0.2;
    else if (Ratio < 0.5)
        Color = 0.1;
    else
        Color = 0.0;
    return (int) (Color * (MaxColors - 1));
}

// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#endif


// =================================================================================== 
#define ParentClass
// =================================================================================== 

// =================================================================================== 
#undef ParentClass
