/*      file     : common/Error.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: Error.h,v 1.6 2005/03/25 11:04:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef ERROR_H
#define ERROR_H

// ***INCLUDES************************************************************************

#include "Basic.h"
#include "TString.h"

// ***TYPES***************************************************************************

typedef long TErrorStatus;

// ***CONSTANTS***********************************************************************

enum TErrorStatusValues

{
    Status_OK,
    Status_UserBreak,
    Status_GeneralError,
    Status_FileNotFound,
    Status_DataError,
    Status_OutOfHeap,
    Status_CommunicationError,
    Status_XAuthorizationFailed,
    Status_SpawnFailed,
    Status_EventNotHandled,
    Status_MessageNotHandled,
    Status_TimeStepMismatch,
    Status_VersionMismatch,
    Status_SegmentationViolation,
    Status_BusError,
    Status_NestedFatalSignal,
    Status_FirstFreeStatus
};

// ***LOCAL VARIABLES***************************************************************** 

extern char         *ErrorDescriptions[];
extern TErrorStatus  ExitCode;
extern TErrorStatus  LocalErrorStatus;
extern TString       LocalErrorFilename;
extern int           LocalErrorIOResult;

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
