/*      file     : common/TArray.i.C
        project  : General Toolbox
        authors  : Marcus Rickert
        RCS      : $Id: TArray.i.C,v 1.4 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

template <class T>
inline T &
TArray<T>::operator[](long Index)

{
#ifdef DRANGECHECK
    if (Index < 0 OR Index >= GetNrOfItems())
        Error("operator[%ld]", Index);
#endif
    return ((T *) Items) [Index];
}

/* =================================================================================== */

template <class T>
inline const T &
TArray<T>::operator[](long Index) const

{
#ifdef DRANGECHECK
    if (Index < 0 OR Index >= GetNrOfItems())
        Error("operator[%ld]", Index);
#endif
    return ((T *) Items) [Index];
}

/* =================================================================================== */

#ifdef DARRAY_VAR_ITEMSIZE
inline long
TArrayPrimitive::GetItemSize(void) const

{
    return ItemSize;
}
#endif

/* =================================================================================== */

inline long
TArrayPrimitive::GetNrOfItems(void) const

{
    return LogicalNrOfItems;
}

// =================================================================================== 

inline long
TArrayPrimitive::GetPhysicalNrOfItems(void) const

{
    return LogicalNrOfItems + DeltaItems;
}

// =================================================================================== 
