/*      file     : common/TContainer.i.C
        project  : General Toolbox
        authors  : Marcus Rickert
        RCS      : $Id: TContainer.i.C,v 1.3 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline bool
TContainer::AutoDisposeEntries(void) const

{
    return GetBaseFlags() & CM_AUTO_DISPOSE_ENTRIES > 0;
}

// =================================================================================== 

inline bool
TContainer::AutoDisposeObjects(void) const

{
    return (GetBaseFlags() & CM_AUTO_DISPOSE_OBJECTS) > 0;
}

// =================================================================================== 

inline TBaseObject *
TContainer::_DisposeContainerEntry(TBaseObject *Entry)

{
    return DisposeContainerEntry(Entry, AutoDisposeEntries(), AutoDisposeObjects());
}

// =================================================================================== 

inline bool
TContainer::DumpEntriesOnDispose(void) const

{
    return (GetBaseFlags() & CM_DUMP_ENTRIES) > 0;
}

// =================================================================================== 

inline bool
TContainer::WarnAboutEntriesOnDispose(void) const

{
    return (GetBaseFlags() & CM_WARN_IF_NOT_EMPTY) > 0;
}

// =================================================================================== 


