/*      file     : common/TDLList.i.C
        project  : General Toolbox
        authors  : Marcus Rickert
        RCS      : $Id: TDLList.i.C,v 1.5 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TDLLIST_IC
#define TDLLIST_IC

// ***METHODS************************************************************************* 

inline void
TDLListEnumPrimitive::operator -- (int)

{
    CurrentIndex = NextIndex;
    NextIndex = Next->GetPrevIndex(NextIndex);
    Current = Next;
    Next = Current->GetPrev(CurrentIndex);
}

/* =================================================================================== */

inline void
TDLListEnumPrimitive::operator ++ (int)

{
    CurrentIndex = NextIndex;
    NextIndex = Next->GetNextIndex(NextIndex);
    Current = Next;
    Next = Current->GetNext(CurrentIndex);
}

/* =================================================================================== */

inline bool
TDLListEnumPrimitive::operator () (void)

{
    if (Current == Head)
    {
        if (CurrentList)
            CurrentList->SetCurrentEnum(0);
        CurrentList = 0;
        return FALSE;
    }
    else
        return TRUE;
}

/* =================================================================================== */

inline int
TDLListEnumPrimitive::GetCurrentIndex(void) const

{
    return CurrentIndex;
}

/* =================================================================================== */

inline TDLListEnumPrimitive *
TDLListPrimitive::GetCurrentEnum(void)

{
    return CurrentEnum;
}

/* =================================================================================== */

inline TListNodePrimitive *
TDLListPrimitive::GetHead(void) const

{
    return (TListNodePrimitive *) &Head;
}

/* =================================================================================== */

inline long
TDLListPrimitive::GetNrOfElements(void) const

{
    return NrOfElements;
}

/* =================================================================================== */

inline bool
TListNodePrimitive::IsInList(const TDLListPrimitive *aList) const

{
    int Index;
    
    return GetListIndex(aList, Index);
}

/* =================================================================================== */

inline void
TDLListPrimitive::SetCurrentEnum(TDLListEnumPrimitive *theEnum)

{
    CurrentEnum = theEnum;
}

/* =================================================================================== */

inline void
TDLListPrimitive::UpdateCurrentEnum(const TListNodePrimitive *Previous, int PreviousIndex)

{
    if (CurrentEnum)
        CurrentEnum->UpdateUponDelete(Previous, PreviousIndex);
}

// =================================================================================== 
#endif
