/*      file     : common/TDataTypeReader.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TDataTypeReader.h,v 1.7 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TDATATYPEREADER_H
#define TDATATYPEREADER_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>
#include <CommonTypes.h>

// ***CLASSES************************************************************************* 

/**
  */

class TDataTypeReader : public TBaseObject

{
public:

    TDataTypeReader(void);
    virtual ~TDataTypeReader(void);
    
    virtual bool
        Eof(void);
    virtual void *
        Get(void) const;
    virtual void *
        Get(LongID Index);
    virtual void *
        GetSelected(long);
    inline long
        GetEntryNumber(void) const;
    virtual bool
        GetLinearIndex(LongID *&Index, long &Count);
    inline double
        GetRandomFraction(void) const;
    inline void
        Next(void);
    virtual bool
        Select(LongID Index, long &Count);
    bool
        StartLinearAccess(void);
    bool
        StartRandomAccess(double theRandomFraction);

protected:

    long LinearReads;
    long RandomReads;

    virtual bool
        PrepareLinearAccess(void);
    virtual bool
        PrepareRandomAccess(void);

private:

    double RandomFraction;
    long   CurrentEntry;
};

// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#  include "TDataTypeReader.i.C"
#endif
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
