/*      file     : common/TID2ContainerEntry.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TID2ContainerEntry.C,v 1.5 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include "TID2ContainerEntry.h"

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TIDContainerEntryPrimitive
// =================================================================================== 

TID2ContainerEntryPrimitive::TID2ContainerEntryPrimitive(long theID, long theID2, 
                                                         const TBaseObject *theDataPtr) :

ParentClass(theID, theDataPtr)

{
    ID2 = theID2;
}

// ===================================================================================

int
TID2ContainerEntryPrimitive::Compare(TBaseObject *OtherObject, int CompareCode) const

{
    TID2ContainerEntryPrimitive *OtherEntry = (TID2ContainerEntryPrimitive *) OtherObject;
    
    int Result;

    if ((Result = ParentClass::Compare(OtherObject, CompareCode)) == 0) 
        if (CompareCode == SELECT_ID_1)
            return 0;
        else
            if (ID2 > OtherEntry->GetID2())
                return 1;
            else
                if (ID2 < OtherEntry->GetID2())
                    return -1;
                else
                    return 0;
    else
        return Result;
}


// =================================================================================== 
#undef ParentClass
