/*      file     : common/TIDContainerEntry.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TIDContainerEntry.h,v 1.8 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TIDCONTAINERENTRY_H
#define TIDCONTAINERENTRY_H

// ***INCLUDES************************************************************************ 

#include "TContainerEntry.h"

// ***CLASSES************************************************************************* 

/**
  */

class TIDContainerEntryPrimitive : public TContainerEntry

{
public:

    TIDContainerEntryPrimitive(long theID, const TBaseObject *theDataPtr);

    virtual int
        Compare(TBaseObject *OtherObject, int CompareCode) const;
    inline long
        GetID(void) const;
    virtual TString
    GetInstanceName(void) const;

private:

    long ID;

};

// ===================================================================================

/**
  */

template < class T >
class TIDContainerEntry : public TIDContainerEntryPrimitive

{
public:
    
    TIDContainerEntry(long theID = INVALID, const T *theDataPtr = 0);

    operator T * (void);
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TIDContainerEntry.i.C"
#endif

// ***TEMPLATE METHODS**************************************************************** 

#if defined (INCLUDE_TEMPLATES) || defined(TEMPLATEBODIES)
#  include "TIDContainerEntry.t.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
