/*      file     : common/TLocation.i.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TLocation.i.C,v 1.4 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <math.h>

// ***METHODS************************************************************************* 

inline TCoordinate
TLocation::ManhattenDistanceTo(const TLocation &OtherLoc) const

{
    return max(fabs(OtherLoc.x() - x()), fabs(OtherLoc.y() - y()));
}

// ===================================================================================

inline TCoordinate 
TLocation::x(void) const

{
    return _X;
}

// ===================================================================================

inline TCoordinate 
TLocation::y(void) const

{
    return _Y;
}

// =================================================================================== 

inline TCoordinate &
TLocation::x(void)

{
    return _X;
}

// ===================================================================================

inline TCoordinate & 
TLocation::y(void)

{
    return _Y;
}

// =================================================================================== 
