/*      file     : common/TParser.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TParser.h,v 1.9 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TPARSER_H
#define TPARSER_H

// ***INCLUDES************************************************************************ 

#include <stdio.h>

#include <Basic.h>
#include <TString.h>
#include <TStream.h>

// ***DEFINES*************************************************************************

#define COMMENT_CHAR             '#'
#define QUOTATION_CHAR           '"'
#define QUOTATION_CHAR_DELIMITER """"
#define TAB_CHAR                 '\t'
#define NEWLINE_CHAR             '\n'
#define DEFAULT_DELIMITERS       " "

// ***CLASSES*************************************************************************

/**
  */

class TParser : public TStream

{
 public:

    TParser(int theNrOfTokens = 0, char **theTokens = 0, 
            char *theDelimiters = " ",
            long MaxInputLineLength = MAX_INPUT_LINE_LENGTH);
    virtual ~TParser(void);

    TString
    GetClassName(void) const;

    int
    GetTokenID(long ExpectedToken = -1) const;

    bool
    FindToken(long TokenID);

 private:

    int       NrOfTokens;
    char    **Tokens;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
