/*      file     : common/TRandom.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TRandom.C,v 1.8 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

/* ***INCLUDES************************************************************************ */

#include <TRandom.h>

/* ***LOCAL VARIABLES***************************************************************** */

long TRandom::BaseSeed = 0;

/* ***METHODS************************************************************************* */

#ifdef NO_INLINE
#  include <TRandom.i.C>
#endif

/* =================================================================================== */

TRandom::TRandom(void)

{
    MaxRand = (1 << 30);
    SetSeed(BaseSeed);
}

/* =================================================================================== */

long
TRandom::GetLimit(double Prob)

{
    return (long) (Prob * (double) MaxRand);
}

/* =================================================================================== */

char *
TRandom::GetName(void)
{
    return "additive integer method";
}

/* =================================================================================== */

void
TRandom::SetSeed(long aSeed)

{
    int  i;
    long Seed;

    Seed = aSeed;
    for (i=0; i<=MAGIC_COUNT; i++)
    {
        Seed=Seed*DEFAULT_FACTOR+DEFAULT_ADD % DEFAULT_MAX_RAND;
        Magic[i]=Seed & 65535;
        Seed=Seed*DEFAULT_FACTOR+DEFAULT_ADD % DEFAULT_MAX_RAND;
        Magic[i]=Magic[i] | ((Seed & 65535) << 16);
    }
    RndJ=FIRST_J;
    RndK=FIRST_K;
    for (i = 0; i < 2 * MAGIC_COUNT; i++)
        Int();
}

/* =================================================================================== */

