/*      file     : common/TRandom.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TRandom.h,v 1.7 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TRANDOM_H
#define TRANDOM_H

/* ***INCLUDES************************************************************************ */

#include <Basic.h>

/* ***DEFINES************************************************************************* */

#define DEFAULT_SEED     4721
#define DEFAULT_MAX_RAND 714025
#define DEFAULT_ADD      150889
#define DEFAULT_FACTOR   1366

#define MAGIC_COUNT      54
#define FIRST_K          54
#define FIRST_J          23

#define RMAR_COUNT       97
#define RMAR_SEED1_MOD   31329
#define RMAR_SEED2_MOD   30082

/* ***CLASSES************************************************************************* */

/**
  */

class TRandom

{
 public:

    TRandom(void);

    inline double
        Double(void);
    static char *
        GetName(void);
    inline long
        Int(long Max);
    long
        GetLimit(double Prob);
    inline long
        GetMaxRand(void);
    inline long
        Int(void);
    inline bool
        IsLower(long Limit);
    void
        SetSeed(long aSeed);

    static long BaseSeed;

 protected:

    long MaxRand;
    long RndK, RndJ;
    long Magic[MAGIC_COUNT + 1];
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#include "TRandom.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
