/*      file     : common/TStringTable.h
        project  : Formale Sprachen
        author   : Marcus Rickert
        objects  : TStringTableEntry<>
                   TStringTable<>
        RCS      : $Id: TStringTable.h,v 1.5 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifdef __GNUC__
#pragma interface
#endif

#ifndef TSTRINGTABLE_H
#define TSTRINGTABLE_H

// ***INCLUDES************************************************************************

#include <Basic.h>
#include <TABTree.h>

#include <TString.h>

// ***CLASSES*************************************************************************

template <class T>
class TStringTableEntry : public TBaseObject

{
 public:

    TStringTableEntry(void);
    TStringTableEntry(const char *aString);
    TStringTableEntry(const char *aString, T ItemPar);

    inline T
        GetItem(void) const;
    inline const char *
        GetKey(void) const;

 private:

    TString  Key;
    T        Item;

    virtual int
        Compare(TBaseObject *OtherObject, int CompareCode) const;
};

// ===================================================================================

template < class DataType >
class TStringTableEnum : public TABTreeEnum< TStringTableEntry< DataType >  >

{
public:

    DataType
        operator -> (void);    
    operator DataType (void);
    void
        Select(TABTreePrimitive &aTree, const char *aString = 0, int CompareCode = 0);
};

// ===================================================================================

template < class DataType >
class TStringTable : public TABTree< TStringTableEntry< DataType >  >

{
 public:

    TStringTable(void) { };

    DataType
        Find(const char *aString, int CompareCode = 0);
};

// ***TEMPLATE METHODS****************************************************************

#if defined (INCLUDE_TEMPLATES) || defined(TEMPLATEBODIES)
#  include "TStringTable.t.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
