/*      file     : parallel/TBusTopology.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TBusTopology.h,v 1.3 2005/03/25 11:06:20 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TBUSTOPOLOGY_H
#define TBUSTOPOLOGY_H

// ***INCLUDES************************************************************************ 

#include <TObjectArray.h>

#include "TTopology.h"

// ***CLASSES************************************************************************* 

/** Topology class representing clusters coupled by a fixed bandwidth bus.
  */

class TBusTopology : public TTopology

{
public:

    TBusTopology(const TDLList<TCPNInfo> *theList = 0);
    virtual ~TBusTopology(void);

private:

    virtual TString
        GetClassName(void) const;
    virtual TTopologyType
        GetType(void) const;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
