/*      file     : communication/TCommunicationControl.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TCommunicationControl.h,v 1.10 2005/03/25 11:06:20 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TCOMMUNICATIONCONTROL_H
#define TCOMMUNICATIONCONTROL_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>
#include <TDLList.h>

#include "ParallelTypes.h"

// ***FORWARDS************************************************************************

class TBaseMessage;
class TCPNInfo;
class TDestination;

// ***CLASSES************************************************************************* 

class TCommunicationControl : public TBaseObject

{
public:

    virtual bool
        Activate(void);
    virtual long
        GetCapabilities(void) const;
    virtual TString
        GetClassName(void) const;
    virtual TBaseMessage *
        GetNewMessage(TMessageID theID, TCPNID theSender, TDestination *theDestination,
                      TMessageTag theTag, TMessageType theType,
                      TMessageFlags theFlags) = 0;
    virtual bool
        IsBlockable(void) const;
    virtual bool
        MessageIsPending(void) const = 0;
    virtual bool
        ReceiveMessage(TBaseMessage *&theMessage, long TimeOut) = 0;
    virtual bool
        ReduceLinearArray(const void* SendBuffer, void* ReceiveBuffer, 
                          int Count, TBaseType BaseType, 
                          TBaseOperation Operation, TCPNID Root);
    virtual bool
        SetEncoding(TEncodingMode theEncoding);
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
