/*      file     : parbalance/TBaseBalancer.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TBaseBalancer.h,v 1.3 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TBASEBALANCER_H
#define TBASEBALANCER_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>

#include <ParallelTypes.h>

// ***FORWARDS************************************************************************

class TTimeStep;

// ***CLASSES************************************************************************* 

class TBaseBalancer : public TBaseObject

{
public:

    TBaseBalancer(void);

    virtual bool
    ExecuteSubTimeStep(TTimeStep &TimeStep);

    virtual bool
    Run(void);

    inline void
    SetLocalLoadValues(double theLocalTime, double theLocalLoad, 
                       double theLocalPerformance);

protected:

    bool
    SetTransferInTimeUnits(TCPNID Destination, TTimeStep &TimeStep, 
                           double MyTime, double MyPerf,
                           double OtherTime, double OtherPerf);

    bool
    SetTransfer(TCPNID Destination, TTimeStep &TimeStep, double TransferLoad);

    bool   Block;
    int    Interval;
    double Dampening;
    double LocalTime;
    double LocalLoad;
    double LocalPerf;
};


// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TBaseBalancer.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
