/*      file     : parbalance/TExtendedLoadStat.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TExtendedLoadStat.C,v 1.5 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TNode.h>

#include "TExtendedLoadStat.h"

// ***GLOBAL VARIABLES****************************************************************  

TClassInfo *TExtendedLoadStat::ClassInfo = 0;

// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#  include "TExtendedLoadStat.i.C"
#endif

// =================================================================================== 
#define ParentClass TLoadStat
// =================================================================================== 

TExtendedLoadStat::TExtendedLoadStat(TParallelID theParallelID) :

ParentClass(ClassInfo, theParallelID)

{
}

// =================================================================================== 

bool
TExtendedLoadStat::ExtendedCollect(const TLocation &theCenterOfGravity,
                                   const TRectangle &theFrame)

{
    CenterOfGravity = theCenterOfGravity;
    Frame = theFrame;
    return TRUE;
}

// =================================================================================== 

bool
TExtendedLoadStat::Decode(TBaseStream *aStream, TTransferInfo *TransferInfo)

{
    return (ParentClass::Decode(aStream, TransferInfo) AND
            CenterOfGravity.Decode(*aStream) AND
            Frame.Decode(*aStream));
}

// =================================================================================== 

bool
TExtendedLoadStat::Encode(TBaseStream *aStream, TTransferInfo *TransferInfo) const

{
    return (ParentClass::Encode(aStream, TransferInfo) AND
            CenterOfGravity.Encode(*aStream) AND
            Frame.Encode(*aStream));
}

// =================================================================================== 

TString
TExtendedLoadStat::GetClassName(void) const

{
    return "TExtendedLoadStat";
}

// =================================================================================== 
#undef ParentClass
