/*      file     : parbalance/TExtendedLoadStat.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TExtendedLoadStat.h,v 1.4 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TEXTENDEDLOADSTAT_H
#define TEXTENDEDLOADSTAT_H

// ***INCLUDES************************************************************************ 

#include <TLocation.h>

#include "TLoadStat.h"

// ***FORWARDS************************************************************************
// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***CLASSES************************************************************************* 

class TExtendedLoadStat : public TLoadStat

{
public:
    
    TExtendedLoadStat(TParallelID theParallelID);

    bool
    ExtendedCollect(const TLocation &theCenterOfGravity, const TRectangle &theFrame);

    inline const TLocation &
    GetCenterOfGravity(void) const;
    
    inline const TRectangle &
    GetFrame(void) const;
    
    static TClassInfo *ClassInfo;

private:


    virtual bool
    Decode(TBaseStream *aStream, TTransferInfo *TransferInfo);

    virtual bool
    Encode(TBaseStream *aStream, TTransferInfo *TransferInfo) const;

    virtual TString
    GetClassName(void) const;

    TLocation  CenterOfGravity;
    TRectangle Frame;
};

// ***TYPES*************************************************************************** 

typedef TDLList < TExtendedLoadStat > TExtendedLoadStatList;
typedef TDLListEnum < TExtendedLoadStat > TExtendedLoadStatEnum;

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TExtendedLoadStat.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
