/*      file     : parbalance/TNeighborCommInfo.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TNeighborCommInfo.C,v 1.2 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TBaseStream.h>
#include <TExtendedCPNInfo.h>
#include <TTransferLoadInfo.h>

#include "TNeighborCommInfo.h"

// ***GLOBAL VARIABLES****************************************************************  

TClassInfo *TNeighborCommInfo::ClassInfo = 0;

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TStatObject
// =================================================================================== 

TNeighborCommInfo::TNeighborCommInfo(TParallelID theParallelID) :

ParentClass(ClassInfo, theParallelID)

{
    Reset();
}

/* =================================================================================== */

TNeighborCommInfo::~TNeighborCommInfo(void)

{
}

/* =================================================================================== */

bool
TNeighborCommInfo::Collect(TExtendedCPNInfo *Info)

{
    TTransferLoadInfo *LoadInfo;

    NrOfBoundaries = Info->BoundaryContainers.GetNrOfElements();
    if ((LoadInfo = (TTransferLoadInfo *) 
         Info->GetInfo(TTransferLoadInfo::ClassInfo->GetInfoID())))
        TransferLoad = LoadInfo->GetTransferLoad();
    return TRUE;
}

/* =================================================================================== */

bool
TNeighborCommInfo::Decode(TBaseStream *aStream, TTransferInfo *TransferInfo)

{
    return (ParentClass::Decode(aStream, TransferInfo) AND
            aStream->Decode(NrOfBoundaries) AND
            aStream->Decode(TransferLoad));
}

/* =================================================================================== */

bool
TNeighborCommInfo::Encode(TBaseStream *aStream, TTransferInfo *TransferInfo) const

{
    return (ParentClass::Encode(aStream, TransferInfo) AND
            aStream->Encode(NrOfBoundaries) AND
            aStream->Encode(TransferLoad));
}

/* =================================================================================== */

TString
TNeighborCommInfo::GetClassName(void) const

{
    return "TNeighborCommInfo";
}

/* =================================================================================== */

void
TNeighborCommInfo::Reset(void)

{
    NrOfBoundaries = 0;
    TransferLoad = 0.0;
}

// =================================================================================== 
#undef ParentClass
