/*      file     : parbalance/TNodeHeapEntry.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TNodeHeapEntry.h,v 1.2 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TNODEHEAPENTRY_H
#define TNODEHEAPENTRY_H

// ***INCLUDES************************************************************************ 

#include <TParallelObject.h>
#include <THeap.h>

// ***FORWARDS************************************************************************

#include <TNode.forward.h>

// ***CLASSES************************************************************************* 

class TNodeHeapEntry : public TParallelObject, public THeapObject

{
public:

    TNodeHeapEntry(TParallelID theParallelID);

    double  Distance;
    double  Load;

    double  Penalty;

    static TClassInfo *ClassInfo;

private:

    virtual int
    HeapCompare(THeapObject *OtherObject, int) const;
};

// ***TYPES*************************************************************************** 

typedef THeap < TNodeHeapEntry > TNodeHeap;

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
