/*      file     : parbalance/TTransferLoadInfo.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TTransferLoadInfo.i.C,v 1.4 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline void
TTransferLoadInfo::Cancel(void)

{
    Mode = NoTransfer;
}

// =================================================================================== 

inline void
TTransferLoadInfo::Confirm(void)

{
    if (Mode != WaitForConfirm)
        Warning("Confirm: not in mode WaitForConfirm");
    Mode = ReceiveLoad;
}

// =================================================================================== 

inline double
TTransferLoadInfo::GetTransferLoad(void) const

{
    return TransferLoad;
}

// =================================================================================== 

inline const TTimeStep &
TTransferLoadInfo::GetCollectTimeStep(void) const

{
    return CollectTimeStep;
}

// =================================================================================== 

inline TMigrationContext *
TTransferLoadInfo::GetMigrationContext(void) const

{
    if (MigrationContext == 0)
        Warning("GetMigrationContext: no context available");
    return MigrationContext;
}

// =================================================================================== 

inline TTransferLoadMode
TTransferLoadInfo::GetMode(void) const

{
    return Mode;
}

// =================================================================================== 

inline int
TTransferLoadInfo::GetNrOfMissingAcks(void) const

{
    return NrOfMissingAcks;
}

// =================================================================================== 

inline int
TTransferLoadInfo::GetNrOfNonReadyCPN(void) const

{
    return NrOfNonReadyCPN;
}

// =================================================================================== 

inline const TTimeStep &
TTransferLoadInfo::GetTransferTimeStep(void) const

{
    return TransferTimeStep;
}

// =================================================================================== 

inline void
TTransferLoadInfo::Set(const TTimeStep &theCollectTimeStep, double theTransferLoad)

{
    CollectTimeStep = theCollectTimeStep;
    TransferLoad = theTransferLoad;
    if (Mode == NoTransfer)
        Mode = TransferSelected;
}

// =================================================================================== 

inline void
TTransferLoadInfo::SetMode(TTransferLoadMode theMode)

{
    Mode = theMode;
}

// =================================================================================== 

inline void
TTransferLoadInfo::SetReceiveTimeStep(const TTimeStep &theTransferTimeStep)

{
    TransferTimeStep = theTransferTimeStep;
    Mode = WaitForConfirm;
}

// =================================================================================== 

inline void
TTransferLoadInfo::SetSendTimeStep(const TTimeStep &theTransferTimeStep, 
                                   TMigrationContext *theContext)

{
    TransferTimeStep = theTransferTimeStep;
    MigrationContext = theContext;
    NrOfMissingAcks = MigrationContext->CPNInfos.GetNrOfElements();
    NrOfNonReadyCPN = MigrationContext->CPNInfos.GetNrOfElements();
    Mode = WaitForAcknowledge;
}

// =================================================================================== 
