/*      file     : partools/TClassInfo.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TClassInfo.i.C,v 1.9 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline TObjectHandlerList &
TClassInfo::GetActionHandlers(void)

{
    return ActionHandlers;
}

// =================================================================================== 

inline TClassInfo *
TClassInfo::GetContainerClass(void) const

{
    return ContainerClass;
}

// =================================================================================== 

inline TClassID
TClassInfo::GetID(void) const

{
    return ClassID;
}

// =================================================================================== 

inline char *
TClassInfo::GetName(void)

{
    return Classname;
}

// =================================================================================== 

inline TClassInfo *
TClassInfo::GetInfoClassInfo(TInfoID theInfoID) const

{
#ifdef DRANGE_CHECK
    if (theInfoID < 0 OR theInfoID > NrOfInfoClasses)
    {
        Error("GetInfoClassInfo: invalid info ID %d", theInfoID);
        return INVALID;
    }
#endif
    return InfoClasses[theInfoID];
}

// =================================================================================== 

inline TInfoID
TClassInfo::GetInfoID(void) const

{
    return InfoID;
}

// =================================================================================== 

inline TInfoMask
TClassInfo::GetInfoMask(void) const

{
    return ((TInfoMask) 1) << InfoID;
}

// =================================================================================== 

inline int
TClassInfo::GetNrOfInfoClasses(void) const

{
    return NrOfInfoClasses;
}

// =================================================================================== 

inline TObjectHandler *
TClassInfo::GetObjectHandler(void) const

{
    return ObjectHandler;
}

// =================================================================================== 

inline TParallelObject *
TClassInfo::GetObjectPtr(TParallelID theParallelID, bool Warn) const

{
    TIDContainerEntry < TParallelObject >  *Entry;

    if (Table == 0)
    {
        Error("GetObjectPtr: no table available");
        return 0;
    }
    if ((Entry = Table->Find(theParallelID)) == 0)
    {
        if (Warn)
            Warning("GetObjectPtr: cannot find ParallelID %ld", theParallelID);
        return 0;
    }
    return *Entry;
}

// =================================================================================== 

TParallelObjectTable *
TClassInfo::GetTable(void) const

{
    return Table;
}

// =================================================================================== 

inline bool
TClassInfo::HasTable(void) const

{
    return (ClassFlags & CI_FLAG_TABLE) != 0;
}

// =================================================================================== 

inline bool
TClassInfo::IsContainer(void) const

{
    return (ClassFlags & CI_FLAG_CONTAINER_CLASS) != 0;
}

// =================================================================================== 

inline bool
TClassInfo::RegisterActionHandler(TObjectHandler *ActionHandler)

{
    ActionHandlers.Append(ActionHandler);
    return TRUE;
}

// =================================================================================== 
