/*      file     : partools/TDistributedRange.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TDistributedRange.h,v 1.7 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TDISTRIBUTEDRANGE_H
#define TDISTRIBUTEDRANGE_H

// ***FORWARDS************************************************************************ 

class TBaseStream;

// ***CLASSES************************************************************************* 

class TDistributedRange

{
 public:

    inline TDistributedRange(double theRangeBegin = 1.0, double theRangeEnd = 0.0);
    
    inline void
    Add(double From, double To);

    bool
    Decode(TBaseStream *Stream);

    bool
    Encode(TBaseStream *Stream) const;

    inline double
    GetFraction(void) const;

    inline double
    GetRangeBegin(void) const;

    inline double
    GetRangeEnd(void) const;

#ifndef INLINE_BUG
    inline 
#endif
    long
    GetLongBegin(long Value) const;
#ifndef INLINE_BUG
    inline 
#endif
    long
    GetLongEnd(long Value) const;

    void
    Invert(void);

    inline bool
    IsActive(void) const;

    inline bool
    IsInRange(double Position) const;

    inline void
    MarkActive(void);

    inline void
    MarkInactive(void);

 private:

    double         RangeBegin;
    double         RangeEnd;
};

// ***INLINE METHODS****************************************************************** 

#ifndef NO_INLINE
#  include "TDistributedRange.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
