/*      file     : partools/TDistributedRange.i.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TDistributedRange.i.C,v 1.6 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline
TDistributedRange::TDistributedRange(double theRangeBegin, double theRangeEnd)

{
    RangeBegin = theRangeBegin;
    RangeEnd = theRangeEnd;
}

// ===================================================================================

inline void
TDistributedRange::Add(double From, double To)

{
    if (From < RangeBegin)
        RangeBegin = From;
    if (To > RangeEnd)
        RangeEnd = To;
}

// ===================================================================================

inline double
TDistributedRange::GetFraction(void) const

{
    if (IsActive())
        return (GetRangeEnd() - GetRangeBegin());
    else
        return 0.0;
}

// ===================================================================================
#ifndef INLINE_BUG
inline long
TDistributedRange::GetLongEnd(long Value) const

{
    return (long) (RangeEnd * (double) Value);
}
#endif
// ===================================================================================
#ifndef INLINE_BUG
inline long
TDistributedRange::GetLongBegin(long Value) const

{
    return (long) (RangeBegin * (double) Value);
}
#endif
// ===================================================================================

inline double
TDistributedRange::GetRangeBegin(void) const

{
    return RangeBegin;
}

// ===================================================================================

inline double
TDistributedRange::GetRangeEnd(void) const

{
    return RangeEnd;
}

// ===================================================================================

inline bool
TDistributedRange::IsActive(void) const

{
    return RangeBegin <= RangeEnd;
}

// ===================================================================================

inline bool
TDistributedRange::IsInRange(double Position) const

{
    if (!IsActive())
        return FALSE;
    if (Position >= RangeBegin AND Position < RangeEnd)
        return TRUE;
    if (Position > RangeBegin AND RangeEnd == 1.0)
        return TRUE;
    return FALSE;       
}

// ===================================================================================

inline void
TDistributedRange::MarkActive(void)

{
    RangeBegin = 0.0;
    RangeEnd = 1.0;
}

// ===================================================================================

inline void
TDistributedRange::MarkInactive(void)

{
    RangeBegin = 1.0;
    RangeEnd = 0.0;
}

// ===================================================================================
