/*      file     : partools/TExtendedCPNInfo.h
        project  : ParallelToolbox
        author   : Marcus Rickert
        RCS      : $Id: TExtendedCPNInfo.h,v 1.6 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TEXTENDEDCPNINFO_H
#define TEXTENDEDCPNINFO_H

// ***INCLUDES************************************************************************ 

#include <TContainerObject.h>

// ***FORWARDS************************************************************************

class TCPNInfo;

// ***DEFINES************************************************************************* 

#define MAX_TIME_LAG 1

// ***CLASSES************************************************************************* 

class TExtendedCPNInfo : public TContainerObject

{
public:

    TExtendedCPNInfo(TCPNID theCPNID);
    TExtendedCPNInfo(TCPNInfo *);

    virtual ~TExtendedCPNInfo(void);

    TCPNInfo             *CPNInfo;
    TContainerObjectList  BoundaryContainers;
    TContainerObjectList  ContainersToBeMigrated;
    TContainerObjectList  DependantsToBeMigrated;
    TContainerObjectList  RequiredToBeMigrated;
    int                   Color;

    static TClassInfo *ClassInfo;
    
private:

};

// ***TYPES*************************************************************************** 

typedef TABTree< TIDContainerEntry< TExtendedCPNInfo > > TExtendedCPNInfoTable;

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
