/*      file     : partools/TLocationInfo.h
        project  : ParallelToolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TLocationInfo.h,v 1.7 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef LOCATIONINFO_H
#define LOCATIONINFO_H

// ***INCLUDES************************************************************************ 

#include <TLocation.h>
#include <TParallelObject.h>

// ***FORWARDS************************************************************************

class TBaseStream;
class TClassInfo;
class TTransferInfo;

// ***GLOBAL VARIABLES****************************************************************  

extern TLocation NullLocation;

// ***CLASSES************************************************************************* 

class TLocationInfo : public TParallelObject

{
public:

    TLocationInfo(TClassInfo *theClassInfo, TParallelID theParallelID);
    virtual ~TLocationInfo(void);
    
    inline TLocation &
        Loc(void);

    virtual bool
        Decode(TBaseStream *, TTransferInfo *);
    virtual bool
        Encode(TBaseStream *, TTransferInfo *) const;

    static TClassInfo * ClassInfo;

private:

    virtual TString
        GetClassName(void) const;
    virtual TString
        GetInstanceName(void) const;

    TLocation Location;
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TLocationInfo.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
