
bool
TPVMMessage::Decode(signed char &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'signed char', count %l", Count);
    if ((PvmError = pvm_upkbyte ((char *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkbyte returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: signed char C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const signed char &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'signed char', count %l", Count);
    if ((PvmError = pvm_pkbyte ((char *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkbyte returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: signed char C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(double &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'double', count %l", Count);
    if ((PvmError = pvm_upkdouble ((double *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkdouble returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: double C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const double &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'double', count %l", Count);
    if ((PvmError = pvm_pkdouble ((double *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkdouble returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: double C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(float &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'float', count %l", Count);
    if ((PvmError = pvm_upkfloat ((float *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkfloat returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: float C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const float &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'float', count %l", Count);
    if ((PvmError = pvm_pkfloat ((float *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkfloat returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: float C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(int &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'int', count %l", Count);
    if ((PvmError = pvm_upkint ((int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkint returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: int C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const int &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'int', count %l", Count);
    if ((PvmError = pvm_pkint ((int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkint returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: int C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(long &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'long', count %l", Count);
    if ((PvmError = pvm_upklong ((long *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upklong returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: long C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const long &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'long', count %l", Count);
    if ((PvmError = pvm_pklong ((long *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pklong returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: long C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(short int &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'short int', count %l", Count);
    if ((PvmError = pvm_upkshort ((short int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkshort returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: short int C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const short int &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'short int', count %l", Count);
    if ((PvmError = pvm_pkshort ((short int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkshort returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: short int C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(unsigned char &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'unsigned char', count %l", Count);
    if ((PvmError = pvm_upkbyte ((char *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkbyte returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: unsigned char C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const unsigned char &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'unsigned char', count %l", Count);
    if ((PvmError = pvm_pkbyte ((char *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkbyte returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: unsigned char C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(unsigned int &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'unsigned int', count %l", Count);
    if ((PvmError = pvm_upkuint ((unsigned int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkuint returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: unsigned int C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const unsigned int &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'unsigned int', count %l", Count);
    if ((PvmError = pvm_pkuint ((unsigned int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkuint returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: unsigned int C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(unsigned long &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'unsigned long', count %l", Count);
    if ((PvmError = pvm_upkulong ((unsigned long *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkulong returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: unsigned long C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const unsigned long &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'unsigned long', count %l", Count);
    if ((PvmError = pvm_pkulong ((unsigned long *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkulong returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: unsigned long C=%ld", Count));
    return TRUE;
}

// ===================================================================================

bool
TPVMMessage::Decode(unsigned short int &Data, long Count, long Stride)

{
    int PvmError;
    
    // Print("decode type 'unsigned short int', count %l", Count);
    if ((PvmError = pvm_upkushort ((unsigned short int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Decode: pvm_upkushort returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Decode: unsigned short int C=%ld", Count));
    return TRUE;
}

// ===================================================================================


bool
TPVMMessage::Encode(const unsigned short int &Data, long Count, long Stride) const

{
    int PvmError;
    
    // Print("Encode type 'unsigned short int', count %l", Count);
    if ((PvmError = pvm_pkushort ((unsigned short int *) &Data, (int) Count, (int) Stride)) < 0)
    {
        Error("Encode: pvm_pkushort returns %d", PvmError);
        return FALSE;
    }
    debug(Print(DM_CODE, "Encode: unsigned short int C=%ld", Count));
    return TRUE;
}

// ===================================================================================
