#      	file     : scripts/RuleMakefile
#      	project  : Parallel Toolbox 2.x
#	author   : Marcus Rickert
#	RCS      : $Id: TExecute.tcsh,v 1.3 2005/03/25 12:28:31 mr Exp $
#
#        Copyright (C) 2005 Marcus Rickert
#
#        http://www.the-rickerts.de/mr/PAMINA.html
#
###############################################################
#             Execute a toolbox application                   #
###############################################################
#                                                             #
# This script is called by $HOME/pvm3/bin/$PVM_ARCH/TExecute. #
# Its location should be $HOME/pvm3/bin which makes it        #
# independent of the PVM architecture. It is run by a tcsh.   #
#                                                             #
# Default parameters:                                         #
#                                                             #
#     $1  name of application                                 #
#     $2  master display                                      #
#                                                             #
# Optional parameters:                                        #
#                                                             #
#     $3  debugging environment                               #
#           choices : XTERM                                   #
#     $4  debugging tool                                      #
#           choices : GDB                                     #
#                                                             #
###############################################################

set path = ( /bin/ /usr/bin /usr/local/bin /vol/bin /vol/usr/bin /vol/local/bin \
             /usr/X11/bin /vol/X11/bin /usr/ucb /usr/gnu/bin /usr/openwin/bin )

echo "TExecute "$*

setenv HOSTNAME `hostname`

setenv DISPLAY $2

setenv LD_LIBRARY_PATH /vol/X11/lib:/vol/X11R6/lib:/usr/openwin/lib

# Debugging environments

setenv XTERM `which xterm`
setenv XXGDB `which xxgdb`

# Debugging tools

if ( "$3" == "xterm" ) then

    if ( "$DEBUGGER" == "" ) then
        setenv DEBUGGER `which $4`
    endif
    echo Using xterm=$XTERM and debugger=$DEBUGGER

    if ( -x $DEBUGGER ) then
        $XTERM -T "Debugging $1 on $HOSTNAME" -e $DEBUGGER $HOME/pvm3/bin/$PVM_ARCH/$1
    else
        echo "TExecute.tcsh: cannot execute xterm or $DEBUGGER !"
        $HOME/pvm3/bin/$PVM_ARCH/$1
    endif
else if ( "$3" == "xxgdb" ) then
    if ( -x $XXGDB ) then
        $XXGDB $HOME/pvm3/bin/$PVM_ARCH/$1
    else
        echo "TExecute.tcsh: cannot execute xxgdb !"
        $HOME/pvm3/bin/$PVM_ARCH/$1
    endif
else
  $HOME/pvm3/bin/$PVM_ARCH/$1
endif
